#ifndef __FS_C__
#define __FS_C__

struct FileSystem_t;
typedef struct FileSystem_t FileSystem_t;

// je met des block de 4096 octet soit 4ko
#define BLOCKSIZE 4096
#define NB_ENTRY_INDEX_TABLE 10
#define NB_ENTRY_FREE_SPACE_TABLE 10
#define NB_ENTRY_DATA_INODE 10
#define SIZE_NAME 255



#include "IndexTable.h"
#include "FreeSpaceTable.h"
#include "Inode.h"
#include "adressetable.h"



struct FileSystem_t{
	int fd;
	IndexTable_t *index_table;
	FreeSpaceTable_t *free_space_table;
	
};

void createfs(const char * filename);
void openfs(FileSystem_t* fs,const char * file);
void writefileinfs(FileSystem_t* fs,const char* chemin, const char * chemin_dest_in_fs);
void removefileinfs(FileSystem_t*fs ,const char* chemin);
void writefiletosystem(FileSystem_t *fd ,const char* chemin_fs,const char * chemin_sortit);
void ListAllFile(FileSystem_t *fs);
void closefs(FileSystem_t* fs);
void defragment(FileSystem_t *fs);
void optimise_file(FileSystem_t *fs);
#endif 
