#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "FileSystem.h"


void help()
{
	printf("./virtualFS C disque.bin : Cree un disque virtuelle\n");
	printf("./virtualFS S disque.bin nom1 nom2 : stocke le fichier nom1 dans le disque virtuel, sous le nom nom2.\n");
	printf("./virtualFS X disque.bin nom1 nom2 : extrait le fichier nom1 du disque virtuel stocké dans disque.bin, dans le fichier nom2.\n");
	printf("./virtualFS R disque.bin nom1 : suprimme le fichiers nom1 du disque.\n");
	printf("./virtualFS L disque.bin : liste toutes les tables d'adresses.\n");
	printf("./virtualFS F disque.bin : liste tous les fichiers du disque.\n");
	printf("./virtualFS D disque.bin : Defragmente les fichiers du disque.\n");

}
int main(int argc, char* argv[])
{

	FileSystem_t mon_disque;

	if(argc > 1)
	{
		if(strcmp(argv[1], "C") == 0)
		{
			if(argc != 3)
			{
				
				help();
				exit(EXIT_FAILURE);
			}
			createfs(argv[2]);  
		}
		else if(strcmp(argv[1], "S") == 0)
		{
			if(argc != 5)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			writefileinfs(&mon_disque,argv[3],argv[4]);
			closefs(&mon_disque);
		}
		else if(strcmp(argv[1], "X") == 0)
		{
			if(argc != 5)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			writefiletosystem(&mon_disque ,argv[3],argv[4]);
			closefs(&mon_disque);
			
		}
		else if(strcmp(argv[1], "L") == 0)
		{
			if(argc != 3)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			showallIndexTable(&mon_disque);
			closefs(&mon_disque);
		}
		else if(strcmp(argv[1], "F") == 0)
		{
			if(argc != 3)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			ListAllFile(&mon_disque);
			closefs(&mon_disque);
		}
		else if(strcmp(argv[1], "D") == 0)
		{
			if(argc != 3)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			defragment(&mon_disque);
			closefs(&mon_disque);
		}
		else if(strcmp(argv[1], "R") == 0)
		{
			if(argc != 4)
			{
				help();
				exit(EXIT_FAILURE);
			}
			openfs(&mon_disque,argv[2]);
			removefileinfs(&mon_disque ,argv[3]);
			closefs(&mon_disque);
		}
		else
		{
			help();
			exit(EXIT_FAILURE);
		}
	}
	else
	{
		if(argc != 3)
		{
			help();
			exit(EXIT_FAILURE);
		}
	}
	
	return 0;
}